"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const generator_helper_1 = require("@prisma/generator-helper");
const sdk_1 = require("@prisma/sdk");
const node_plop_1 = __importDefault(require("node-plop"));
const path = __importStar(require("path"));
const ramda_1 = require("ramda");
const transformDMMF_1 = require("./generator/transformDMMF");
// eslint-disable-next-line @typescript-eslint/no-var-requires
// const pkg = require('../package.json');
const formatAliases = {
    javascript: 'js',
    typescript: 'ts',
    js: 'js',
    ts: 'ts',
};
const withDefaults = (0, ramda_1.mergeRight)({
    outputFormat: formatAliases.js,
});
(0, generator_helper_1.generatorHandler)({
    onManifest() {
        return {
            defaultOutput: './sequelize',
            prettyName: 'Sequelize Models',
        };
    },
    async onGenerate(options) {
        if (!options.generator.output) {
            throw new Error('No output was specified for Prisma Sequelize Generator');
        }
        const generatorConfig = withDefaults(options.generator.config);
        if (!Object.keys(formatAliases).includes(generatorConfig.outputFormat)) {
            throw new Error(`Incorrect output format was specified. Allowed formats are: ${Object.keys(formatAliases)}`);
        }
        const outputFormat = (0, ramda_1.prop)(generatorConfig.outputFormat, formatAliases);
        const outputDir = 
        // This ensures previous version of prisma are still supported
        typeof options.generator.output === 'string'
            ? options.generator.output
            : (0, sdk_1.parseEnvValue)(options.generator.output);
        try {
            const plop = (0, node_plop_1.default)(path.join(__dirname, '../plop/plopfile.js'), { destBasePath: outputDir, force: true });
            // const utilsGenerator = plop.getGenerator('utils');
            const indexGenerator = plop.getGenerator('index');
            const modelGenerator = plop.getGenerator('Model');
            const config = {
                datasource: options.datasources[0],
            };
            // const relativeOutputDir = path.relative(process.cwd(), outputDir);
            // const slsRelativeOutputDir = path.relative(process.cwd(), outputDir).split(path.sep).slice(1).join(path.sep);
            const { models } = (0, transformDMMF_1.transformDMMF)(options.dmmf);
            await Promise.all([
                // utilsGenerator.runActions({}),
                indexGenerator.runActions({ models, config: JSON.stringify(config, null, 2), outputFormat }),
                ...models.map((model) => modelGenerator.runActions({ ...model, outputFormat })),
            ]);
        }
        catch (e) {
            console.error('Error: unable to write files for Prisma Sequelize Generator');
            throw e;
        }
    },
});
